=== debian/changelog ===
freerdp2 (2.0.0.4-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 08a493f4d24c72a55d13d0166860cb68c06070f3']

 -- shuttle <shuttle@deepin.com>  Thu, 29 Oct 2020 12:35:01 +0000
