=== debian/changelog ===
freerdp2 (2.0.0.5-deepin1) unstable; urgency=medium

  * fix CVE-2021-41160.

 -- liaoyuan <liaoyuan@uniontech.com>  Tue, 29 Nov 2022 09:19:40 +0800

freerdp2 (2.0.0.3-1+dde) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-13398 CVE-2020-13396 CVE-2020-11019 CVE-2020-11098 CVE-2020-13397 CVE-2020-11086 CVE-2020-11087 CVE-2020-11088 CVE-2020-11095 CVE-2020-4033 CVE-2020-11038


 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 11 Sep 2020 17:56:20 +0800
