## freerdp2 2.1.1+dfsg1

=== debian/changelog ===
freerdp2 (2.1.1+dfsg1-0ubuntu0.19.10.1) eoan-security; urgency=medium

  * Updated to 2.1.1 to fix multiple security issues.
    - debian/rules: set WITH_PROXY=OFF for now.
    - debian/control: add libcairo2-dev to Build-Depends.
    - debian/rules: set WITH_CAIRO=ON.
    - debian/*symbols: updated for new version.
    - CVE-2019-17177, CVE-2020-11042, CVE-2020-11044, CVE-2020-11045,
      CVE-2020-11046, CVE-2020-11047, CVE-2020-11048, CVE-2020-11049,
      CVE-2020-11058, CVE-2020-11521, CVE-2020-11522, CVE-2020-11523,
      CVE-2020-11524, CVE-2020-11525, CVE-2020-11526, CVE-2020-13396,
      CVE-2020-13397, CVE-2020-13398

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 25 May 2020 12:58:15 -0400
