## freerdp2 2.2.0%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: x11
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
+XSBC-Original-Maintainer: Debian Remote Maintainers <pkg-remote-team@lists.alioth.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Bernhard Miklautz <bernhard.miklautz@shacknet.at>,
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper (>= 11~),
  docbook-xsl,
  dpkg-dev (>= 1.16.1.1),
  libasound2-dev,
@@ -46,7 +46,7 @@
  xmlto,
  xsltproc,
  libicu-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.1.3
 Homepage: http://www.freerdp.com/
 Vcs-Browser: https://salsa.debian.org/debian-remote-team/freerdp2
 Vcs-Git: https://salsa.debian.org/debian-remote-team/freerdp2.git
