=== debian/rules ===
--- 
+++ 
@@ -79,10 +79,7 @@
 override_dh_install:
 	rm -rf debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freerdp/
-	dh_install
-
-override_dh_missing:
-	dh_missing --fail-missing
+	dh_install --fail-missing
 
 override_dh_strip:
 	dh_strip -plibfreerdp2-2 --dbgsym-migration='libfreerdp2-dbg (<< 2.0.0~git20161130.1.e60d0d5+dfsg1-1~exp1~)'
@@ -133,9 +130,7 @@
 	        client/Mac/ \
 	        client/Windows/ \
 	        scripts/OpenSSL-DownloadAndBuild.command \
-	        winpr/libwinpr/crt/utf.* \
-	    && $(RM) -r .git .git* \
-	    && echo "$(UREV)+debian" > .source_version
+	    && $(RM) -r .git .git*
 	@echo "# Packing..."
 	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
 	    | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
